// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Fri Aug 13 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef ArtCompressibleFixPFlux_HH
#define ArtCompressibleFixPFlux_HH

#include <mouse_config.h>

class ArtCompressibleFixPFlux;

#include <mouse_types.hh>
#include <ConstructArg.hh>
#include <IncompressibleOperator2D.hh>

/**
*/
class ArtCompressibleFixPFlux2D : public IncompressibleOperator2D
{
protected:
  /** */ real p_fix;

public:
  /** */ ArtCompressibleFixPFlux2D (carg_t arg);
  /** */ virtual ~ArtCompressibleFixPFlux2D ();
  /** */ void comp_fluxes(size_t i, real nx, real ny);
  /** */ void operate(size_t ie, size_t ip, size_t from, size_t to, 
		      real nx, real ny, bool mod_from, bool mod_to);
};

inline void ArtCompressibleFixPFlux2D::comp_fluxes(size_t i, real nx, real ny)
{
  res_p[i] += (u[i]*beta_q)*nx + (v[i]*beta_q)*ny;
  res_u[i] += (u[i]*u[i]+p_fix)*nx + (u[i]*v[i])*ny;
  res_v[i] += (v[i]*u[i])*nx + (v[i]*v[i]+p_fix)*ny;
};

inline void ArtCompressibleFixPFlux2D::operate(size_t ie, size_t ip, 
					       size_t from, size_t to, 
					       real nx, real ny, 
					       bool mod_from, bool mod_to)
{
  if (mod_from) comp_fluxes(from, nx, ny);
  if (mod_to) comp_fluxes(to, nx, ny);
};


#endif









