#ifndef CellProjection2D_HH
#define CellProjection2D_HH

class CellProjection2D;

#include <TList.hh>

/**
   a function to evaluate the projection of a cell.
   This is based on a discussion with Ales.
*/
class CellProjection2D
{
protected:
  /** */
  struct vec {
    real nx, ny;
    vec() { nx=0; ny=0; };
    vec(real a_nx, real a_ny) { nx = a_nx; ny = a_ny; };
  };

  /** */ TList<vec> *V;

public:
  /** */ CellProjection2D();
  /** */ virtual ~CellProjection2D();
  /** */ void Reset();
  /** */ void AddVector(real nx, real ny);
  /** */ real calc(real alpha);
};

inline real CellProjection2D::calc(real alpha)
{
  real sum = 0;
  real cosa = cos(alpha);
  real sina = sin(alpha);
  FORALL(i, V->) sum += fabs(V->At(i).nx*cosa + V->At(i).ny*sina);
  return sum;
};

#endif
