// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Sat Jun 5 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "CompressibleBViscFlux2D.hh"

CompressibleBViscFlux2D::CompressibleBViscFlux2D(carg_t arg)
  : CompressibleOperator2D(arg)
{
  AddClassName();
  Reynolds = PARA->RealParam("Reynolds");
  Ref_length = PARA->RealParam("Ref_length");
  Ref_length = 1.0/Ref_length;
  Prandl = PARA->RealParam("Prandl");
  Re_ref = Reynolds * Ref_length / (Mach_oo * sqrt(gamma));
  Fkenn2=2.0/3.0/Re_ref;
  Fkenn3=1.0/Re_ref;
  Fkenn4=gamma/(gamma1*Prandl*Re_ref);
  drho_dx = VL->Get1DVar("gradx", "rho");
  drhou_dx = VL->Get1DVar("gradx", "rhou");
  drhov_dx = VL->Get1DVar("gradx", "rhov");
  drhoE_dx = VL->Get1DVar("gradx", "rhoE");
  drho_dy = VL->Get1DVar("grady", "rho");
  drhou_dy = VL->Get1DVar("grady", "rhou");
  drhov_dy = VL->Get1DVar("grady", "rhov");
  drhoE_dy = VL->Get1DVar("grady", "rhoE");
};

CompressibleBViscFlux2D::~CompressibleBViscFlux2D()
{
};

