// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#ifndef CompressibleFFlux2D_HH
#define CompressibleFFlux2D_HH

class CompressibleFFlux2D;

#include <CompressibleOperator2D.hh>

/** */
class CompressibleFFlux2D : public CompressibleOperator2D
{
protected:
  /** from side density */
  VarContainer::var1_t rho_from;

  /** from side x momentum */
  VarContainer::var1_t rhou_from;

  /** from side y momentum */
  VarContainer::var1_t rhov_from;

  /** from side energy */
  VarContainer::var1_t rhoE_from;

  /** to side density */
  VarContainer::var1_t rho_to;

  /** to side x momentum */
  VarContainer::var1_t rhou_to;

  /** to side y momentum */
  VarContainer::var1_t rhov_to;

  /** to side energy */
  VarContainer::var1_t rhoE_to;

  /** average density */
  VarContainer::var1_t rho_av;

  /** average x momentum */
  VarContainer::var1_t rhou_av;

  /** average y momentum */
  VarContainer::var1_t rhov_av;

  /** average energy */
  VarContainer::var1_t rhoE_av;

public:
  /** */ CompressibleFFlux2D(carg_t arg);
};

#endif












