// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "CompressiblePressureValue2D.hh"

CompressiblePressureValue2D::CompressiblePressureValue2D(ConstructArg arg) : IsoValue(arg)
{
  AddClassName();
  PARA = ResolveVar<Parameter>(arg);
  gamma = PARA->RealParam("gamma");
  string field_name = arg.P->ReadString();
  VL = FindObject<VarList>(false, true);
  rho = VL->Get1DVar(field_name, "rho");
  rhou = VL->Get1DVar(field_name, "rhou");
  rhov = VL->Get1DVar(field_name, "rhov");
  rhoE = VL->Get1DVar(field_name, "rhoE");
};

void CompressiblePressureValue2D::CalcValues()
{
  FORALL(i, PL->) {
    plot_value->At(i) = (gamma-1) * 
      (rhoE[i]-.5/rho[i]*(rhou[i]*rhou[i]+rhov[i]*rhov[i]));
  };
};


