// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Mon May 17 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef ComputeMaxRes_HH
#define ComputeMaxRes_HH

#include <mouse_config.h>

class ComputeMaxRes;

#include <mouse_types.hh>
#include <ConstructArg.hh>
#include <Action.hh>
#include <CflManager.hh>
#include <MgAllLevelCflManager.hh>
#include <VarList.hh>
#include <PointList.hh>
#include <MultiGridAgent.hh>
#include <PopList2D.hh>

/**
   compute the maximal residual, using the difference between two fields
*/
class ComputeMaxRes : public Action
{
protected:
  /** */ VarList *VL;
  /** */ PointList *PL;
  /** */ VarContainer::var2_t var1;
  /** */ VarContainer::var2_t var2;
  /** */ real *max_value;
  /** */ real *l2_value;
  /** */ MultiGridAgent<PopList2D> *mga;

public:
  /** */ ComputeMaxRes (carg_t arg);
  /** */ virtual ~ComputeMaxRes ();
  /** */ virtual void Act();
  /** */ real MaxRes(size_t iv) { return max_value[iv]; };
  /** */ real L2Res(size_t iv) { return l2_value[iv]; };
};


#endif
