// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "ConstructArg.hh"
#include <stdarg.h>
#include <IStreamParser.hh>
#include <CppParser.hh>
#include <strstream.h>
#include <EmptyParser.hh>
#include <MouseMain.hh>

//
//.. constructor
//
ConstructArg::ConstructArg ()
{
  P = NULL;
  parent = NULL;
};

ConstructArg::ConstructArg (MObject *a_parent, Parser *a_P)
{
  //if (P != NULL) P->DefineAsGarbage();
  parent = a_parent;
  if (a_P != NULL) P = a_P;
  else P = new EmptyParser(parent);//MouseMain::Top());
};

ConstructArg::ConstructArg (MObject *a_parent, const char *form, ...)
{
  IStreamParser *IP = new IStreamParser(MouseMain::Top());//a_parent);
  IP->DefineAsGarbage();
  P = IP;
  parent = a_parent;
  va_list arg;
  va_start(arg, form);
  istrstream s(form);
  string type;
  while (!s.eof()) {
    s >> type;
    if (type == "int") IP->Add(va_arg(arg, int));
    if (type == "string") IP->Add(string(va_arg(arg, char*)));
    if (type == "real") IP->Add(va_arg(arg, real));
    IP->Add(string(" "));
  };
  IP->PreProcess();
};

//
//.. operator=
//
void ConstructArg::operator= (MObject* obj)
{
  parent = obj;
  P = new EmptyParser(MouseMain::Top());
};

















