// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#if !defined(CppConstructArg_HH)
#define CppConstructArg_HH

class CppConstructArg;
template <class T> class ccsubarg_t;
template <class T> class CppSubArg;

#include <ConstructArg.hh>
#include <CppParser.hh>
#include <MObject.hh>
#include <Communicator.hh>

/** */
class CppConstructArg : public ConstructArg
{
public:
  /** */ CppConstructArg();
  /** */ CppConstructArg(MObject *a_parent);
  /** */ CppConstructArg(const CppConstructArg &ccarg);
  /** */ void operator=(const CppConstructArg &ccarg);
  /** */ template <class T> CppConstructArg operator+ (const T a_T);
  /** */ template <class T> CppConstructArg operator+ (const T *a_T);
};

template<class T>
CppConstructArg CppConstructArg::operator+(const T a_T)
{
  CppConstructArg new_arg(*this);
  CppParser *cppP = dynamic_cast<CppParser*>(new_arg.P);
  cppP->Add(a_T);
  return new_arg;
};

template<class T>
MObject* ccarg_var(T *a_T)
{
  MObject *mobj = dynamic_cast<MObject*>(a_T);
  if (mobj == 0) {
    cerr << "only MObjects are allowed for 'ccarg_var'" << endl;
    exit(EXIT_FAILURE);
  };
};

typedef CppConstructArg ccarg_t;

/** */
template<class T> string class_n() { return typeid(T).name(); };

#endif

















