// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#ifndef EmptyParser_HH
#define EmptyParser_HH

class EmptyParser;

#include <Parser.hh>
#include <ConstructArg.hh>
#include <string>

/** */
class EmptyParser : public Parser
{
  /** */ void ReadAttempt() { Error("trying to read from an 'EmptyParser'"); };

public:
  /** */ EmptyParser(MObject *a_parent);
  /** */ virtual int ReadInt() { ReadAttempt(); return 0; };
  /** */ virtual size_t ReadIndex() { ReadAttempt(); return 0; };
  /** */ virtual real ReadReal() { ReadAttempt(); return 0; };
  /** */ virtual string ReadString() { ReadAttempt(); return ""; };
  /** */ virtual bool ReadBool() { ReadAttempt(); return false; };
  /** */ virtual Parser* SubParser();
  /** */ virtual void Reset() {}; //?? Error("cannot reset an 'EmptyParser'"); };
  /** */ virtual bool eof() { return true; };
};

#endif







