// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Wed Jul 14 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef IncompressibleTWall2D_HH
#define IncompressibleTWall2D_HH

#include <mouse_config.h>

class IncompressibleTWall2D;

#include <mouse_types.hh>
#include <ConstructArg.hh>
#include <IncompressibleOperator2D.hh>
#include <BoundaryPointList.hh>

/**
*/
class IncompressibleTWall2D : public IncompressibleOperator2D
{
protected:
  /** */ BoundaryPointList *BPL;
public:
  /** */ IncompressibleTWall2D (carg_t arg);
  /** */ virtual ~IncompressibleTWall2D ();
  /** */ void operate (size_t i_tmp, size_t i);
};

inline void IncompressibleTWall2D::operate(size_t i_tmp, size_t i)
{
  real uv_n = u[i] * BPL->Nx(i) + v[i] * BPL->Ny(i);
  u[i] = u[i] - uv_n * BPL->Nx(i);
  v[i] = v[i] - uv_n * BPL->Ny(i);
};


#endif
