// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Mon Aug 23 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "LoadBoundaries2D.hh"

LoadBoundaries2D::LoadBoundaries2D(carg_t arg)
  : Mesh2DGeometryAction(arg)
{
  AddClassName();
  filename = arg.P->ReadString();
  filename += ".geom";
};

LoadBoundaries2D::~LoadBoundaries2D()
{
};

void LoadBoundaries2D::Act()
{
  ifstream f(filename.c_str());
  size_t N;
  f >> N;
  size_t p0=0, p1=0, p2=0;
  real x0, y0, x1, y1;
  int code;
  f >> x0 >> y0 >> code;
  if (f.fail()) Error("file format error");
  p1 = PL->AddEntry();
  MESH->FixPoint(p1);
  MESH->SetMatrixComp(p1, 0, 0, 0);
  MESH->SetNetDensity(p1, 0);
  PL->x(p1) = x0;
  PL->y(p1) = y0;
  PL->code(p1) = code;
  p0 = p1;
  for (size_t i = 1; i < N; i++) {
    f  >> x1 >> y1 >> code;
    p2 = PL->AddEntry();
    MESH->FixPoint(p2);
    MESH->SetMatrixComp(p2, 0, 0, 0);
    MESH->SetNetDensity(p2, 0);
    PL->x(p2) = x1;
    PL->y(p2) = y1;
    PL->code(p2) = code;
    TRI->AddFront(p2, p1);
    p1 = p2;
  };
  TRI->AddFront(p0, p2);
};






