// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#if !defined(MLIST_HH)
#define MLIST_HH

#include "MObject.hh"

/**
   base class for MObjects using List as a basis.
   There are two different ways of constructing an MList
   using MCL. \\
   It can be constructed by giving an initial max_num_entries
   and an icrement, or it can be constructed by giving a reference
   to another List.
   \\ \\
   {\bf MCL syntax:}
   \begin{verbatim}
   MList { 
     int [max_num_entries]
     int [delta_entries]
   }
   \end{verbatim}
   \\ \\
   \begin{verbatim}
   MList { 
     var [another List to use as a master]
   }
   \end{verbatim}
*/
class MList : public MObject, public List
{
protected:
  /** */ virtual void Extend(long int delta);

public:
  /** */ MList(ConstructArg arg);
  /** */ virtual void CleanUp();
};

#endif










