// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include <mouse_config.h>
#ifdef WITH_QT
#include "MQObjectTreeItem.hh"
#include <Communicator.hh>

MQObjectTreeItem::MQObjectTreeItem(carg_t a, QListViewItem *parent, MObject *a_mobj)
  : QListViewItem(parent), MObject(a)
{
  AddClassName();
  mobj = a_mobj;
  setText(0, mobj->TopClassName().c_str());
  setText(1, mobj->ID().c_str());
  setText(2, mobj->MeshID().c_str());
  if (mobj->IsGarbage()) {
    setText(3, "yes");
  } else {
    setText(3, " ");
  };
  return_string = new char[10];
};

MQObjectTreeItem::MQObjectTreeItem(carg_t a, QListView *parent, MObject *a_mobj)
  : QListViewItem(parent), MObject(a)
{
  AddClassName();
  mobj = a_mobj;
  setText(0, mobj->TopClassName().c_str());
  setText(1, mobj->ID().c_str());
  setText(2, mobj->MeshID().c_str());
  if (mobj->IsGarbage()) {
    setText(3, "yes");
  } else {
    setText(3, " ");
  };
  return_string = new char[10];
};

MQObjectTreeItem::~MQObjectTreeItem()
{
  delete [] return_string;
};

const char* MQObjectTreeItem::key(int column, bool ascending) const
{
  strcpy(return_string, "");
  if (mobj == mobj->Ancestor()) {
    strcpy(return_string, "0");
  } else {
    MObject *child = mobj->Parent()->FirstChild();
    int count = 0;
    while (child != NULL) {
      if (child == mobj) {
	sprintf(return_string, "%d", count);
	break;
      };
      count++;
      child = child->NextSibling();
    };
    if (child == NULL) Bug();
  };
  //return QString(return_string);
  return return_string;
};

#endif







