// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

/**********************************************************************

	--- Qt Architect generated file ---

	File: MQPlotWindow.cc
	Last generated: Tue Jul 21 13:02:43 1998

 *********************************************************************/

#include <mouse_config.h>
#ifdef WITH_QT

#include "MQPlotWindow.hh"
#include "MQPlotWindowData.cc"
#include <MQPlotter.hh>


MQPlotWindow::MQPlotWindow(ConstructArg arg, QWidget* parent, const char* name)
  : MQPlotWindowData( parent, name ), MObject(arg)
{
  AddClassName();
  plot_widget = new MQPlotWidget(this, this);
  panel_width = 130;
  panel_height = 600;
  left_margin = 0;
  right_margin = 0;
  top_margin = menu_bar->height();
  bottom_margin = 0;
  plot_widget->setGeometry(panel_width + left_margin, top_margin, 
			   width() - panel_width - left_margin - right_margin, 
			   height() - top_margin - bottom_margin);
  file_menu = new QPopupMenu();
  menu_bar->insertItem("File", file_menu);
  file_menu->insertItem("print", plot_widget, SLOT(Print()));
  file_menu->insertItem("close", this, SLOT(accept()));
  view_menu = new QPopupMenu();
  config_menu = new QPopupMenu();
  view_menu->setCheckable(true);
  menu_bar->insertItem("View", view_menu);
  menu_bar->insertItem("Options", config_menu);
  int i;
  plot_menu_id = new int[plot_widget->num_plotters];
  config_menu_id = new int[plot_widget->num_plotters];
  for (i = 0; i < plot_widget->num_plotters; i++) {
    plot_menu_id[i] = view_menu->insertItem(plot_widget->plotter[i]->Text().c_str());
    view_menu->setItemChecked(plot_menu_id[i], plot_widget->plotter_active[i]);
    config_menu_id[i] = config_menu->insertItem(plot_widget->plotter[i]->Text().c_str());
  };
  connect(view_menu, SIGNAL(activated(int)), this, SLOT(CheckViewMenu(int)));
  connect(config_menu, SIGNAL(activated(int)), this, SLOT(StartConfigDlg(int)));
  plot_option_checking = false;
};


MQPlotWindow::~MQPlotWindow()
{
  delete [] plot_menu_id;
  delete [] config_menu_id;
};

void MQPlotWindow::resizeEvent(QResizeEvent *E)
{
  left_panel->setGeometry(0, 0, panel_width, height());
  plot_widget->setGeometry(panel_width + left_margin, top_margin, 
			   width() - panel_width - left_margin - right_margin, 
			   height() - top_margin - bottom_margin);
};

void MQPlotWindow::CheckViewMenu(int id)
{
  int i;
  for (i = 0; i < plot_widget->num_plotters; i++) {
    if (plot_menu_id[i] == id) {
      plot_widget->plotter_active[i] = !plot_widget->plotter_active[i];
      view_menu->setItemChecked(plot_menu_id[i], plot_widget->plotter_active[i]);
    };
  };
};

void MQPlotWindow::StartConfigDlg(int id)
{
  int i;
  QDialog *dlg;
  for (i = 0; i < plot_widget->num_plotters; i++) {
    if (plot_menu_id[i] == id) {
      dlg = plot_widget->plotter[i]->CreateConfigDlg(this);
      dlg->show();
    };
  };
};

#endif








