// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#if !defined(MUSCLPROJECTOR2D1_HH)
#define MUSCLPROJECTOR2D1_HH

class MusclProjector2D1;

#include <MusclProjector2D.hh>

/** */
class MusclProjector2D1 : public MusclProjector2D
{
public:
  /** */ MusclProjector2D1(ConstructArg arg) : MusclProjector2D(arg) { AddClassName(); };
  /** */ void operate(size_t ie, size_t ip, size_t from, size_t to, 
		      real nx, real ny, bool mod_from, bool mod_to);
};

inline void MusclProjector2D1::operate(size_t ie, size_t ip, 
				       size_t from, size_t to, 
				       real nx, real ny, 
				       bool mod_from, bool mod_to)
{
  for (size_t iv = 0; iv < VL->NumVars(); iv++) {
    var_h[iv][ie] = .5*(var_point[iv][from] + var_point[iv][to]); 
    var_from[iv][ie] = upw*var_point[iv][from]+(1-upw)*var_h[iv][ie];
    var_to[iv][ie] = upw*var_point[iv][to]+(1-upw)*var_h[iv][ie];
  };
};

#endif









