// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "Operator.hh"

Operator::Operator(ConstructArg arg) : MObject(arg)
{
  AddClassName();
  pcalc = dynamic_cast<PointCalculator*>(Parent());
  if (pcalc == 0) {
    Error("an 'Operator' must be a direct child of a 'PointCalculator'");
  };
  thread_id = pcalc->ThreadID();
  p_operation = LookForObject<POperation>(true, true);
  if (p_operation == NULL) {
    Error("a 'PointCalculator' must be a child object of a 'POperation'");
  };
  //p_operation = dynamic_cast<POperation*>(pcalc->Parent());
  edge_tmp = p_operation->EdgeTmp(thread_id);
  point_tmp = p_operation->PointTmp(thread_id);
  VL = LookForObject<VarList>(false, true);
  if (VL != NULL) {
    for (size_t i = 0; i < VL->NumVars(); i++) {
      edge_tmp->AddVar(VL->VarName(i));
      point_tmp->AddVar(VL->VarName(i));
    };
  };
  PL = FindObject<PointList>(false, true);
};








