// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Wed May 12 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "PrintFieldSum.hh"

PrintFieldSum::PrintFieldSum(carg_t arg)
  : Action(arg)
{
  AddClassName();
  field_name = arg.P->ReadString();
  VL = FindObject<VarList>(false,true);
  var = VL->Get2DVar(field_name);
};

PrintFieldSum::~PrintFieldSum()
{
};

void PrintFieldSum::Act()
{
  cout << "The sum of the field \"" << field_name << "\" is:\n";
  for(size_t i= 0; i < VL->NumVars(); i++) {
    real sum = 0;
    FORALL(j,VL->) sum += var[i][j];
    cout << VL->VarName(i) << " = " << sum << endl;
  };
  cout << endl;
};


