// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Mon May 17 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "ResCondition.hh"

ResCondition::ResCondition(carg_t arg)
  : Condition(arg)
{
  AddClassName();
  R1 = ResolveVar<ComputeMaxRes>(arg);
  R2 = ResolveVar<ComputeMaxRes>(arg);
  K = arg.P->ReadReal();
  VL = FindObject<VarList>(false, true);
};

ResCondition::~ResCondition()
{
};

void ResCondition::Act()
{
  return_value = false;
  for (size_t iv = 0; iv < VL->NumVars(); iv++) {
    //cout << "R1:" << R1->MaxRes(iv) << " R2:" << R2->MaxRes(iv) << endl;
    if (K*R1->MaxRes(iv) > R2->MaxRes(iv)) {
      return_value = true;
      break;
    };
  };
};
