// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

/**********************************************************************

	--- Qt Architect generated file ---

	File: VectorplotConfigDlg.cc
	Last generated: Sat Oct 3 19:19:24 1998

 *********************************************************************/
#include <mouse_config.h>
#ifdef WITH_QT

#include "VectorplotConfigDlg.hh"
#include "VectorplotConfigDlgData.cc"
#include <qvalidator.h>


//
//.. constructor
//
VectorplotConfigDlg::VectorplotConfigDlg(MQVectorPlotter *a_plotter,
					 QWidget* parent, 
					 const char* name) 
  : VectorplotConfigDlgData( parent, name )
{
  plotter = a_plotter;
  int i;
  for (i = 0; i < plotter->NumVecs(); i++) {
    selector->insertItem(plotter->VecV(i)->Text().c_str());
  };
  scale_edit->setValidator(new QDoubleValidator(this));
  length_edit->setValidator(new QDoubleValidator(this));
  GetValues();
  GetFlags();
}

//
//.. GetFlags
//
void VectorplotConfigDlg::GetFlags()
{
  radio_fixed->setChecked(plotter->fixed);
  radio_scaled->setChecked(plotter->scaled);
};

//
//.. GetValues
//
void VectorplotConfigDlg::GetValues()
{
  QString s;
  s = s.setNum(plotter->scale_factor);
  scale_edit->setText(s);
  s = s.setNum(plotter->fixed_length);
  length_edit->setText(s);
};

//
//.. AcceptChanges
//
void VectorplotConfigDlg::AcceptChanges()
{
  QString scale_s(scale_edit->text());
  QString length_s(length_edit->text());
  plotter->SetVec(selector->currentItem());
  plotter->scale_factor = scale_s.toDouble();
  plotter->fixed_length = length_s.toDouble();
  plotter->scaled = radio_scaled->isChecked();
  plotter->fixed = radio_fixed->isChecked();
  plotter->CalcValues();
  accept();
};

VectorplotConfigDlg::~VectorplotConfigDlg()
{
}

#endif







