#ifndef CircularBlock2D_CC
#define CircularBlock2D_CC

#include <geometry2D.hh>

template<class POP>
CircularBlock2D<POP>::CircularBlock2D(carg_t arg) : StructuredBlock2D<POP>(arg)
{
  AddClassName();
  size_t a_imax = arg.P->ReadIndex();
  size_t a_jmax = arg.P->ReadIndex();
  InitBlock(a_imax, a_jmax);
  real x0 = arg.P->ReadReal();
  real y0 = arg.P->ReadReal();
  real ri = arg.P->ReadReal();
  real ro = arg.P->ReadReal();
  i_linked = true;
  real rji = log(ri);
  real rjo = log(ro);
  real drj = (rjo-rji)/(jmax-1);
  for (size_t i=0; i<imax; i++) {
    for (size_t j=0; j<jmax; j++) {
      real rj = rjo+j*drj;
      real r = exp(rj);
      real x,y;
      PolToCart(r,-2*M_PI/imax*i,x0,y0,x,y);
      Set(i, j, x, y);
    };
  };
  AddEdgesToPop();
};

#endif
