// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Sun May 2 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef CoarseGridBResCorr_HH
#define CoarseGridBResCorr_HH

#include <mouse_config.h>

template <class POP> class CoarseGridBResCorr;

#include <mouse_types.hh>
#include <ConstructArg.hh>
#include <Operator.hh>
#include <MultiGridAgent.hh>

/**
*/
template <class POP>
class CoarseGridBResCorr : public Operator
{
protected:
  /** this level's agent */
  MultiGridAgent<POP> *mga;

  /** a variable for the residuuals */
  VarContainer::var2_t res;

public:
  /** */ CoarseGridBResCorr (carg_t arg);
  /** */ virtual ~CoarseGridBResCorr ();
  /** */ void operate(size_t i_tmp, size_t i) {
    size_t i_agglo = mga->FieldNode(i);
    for (uint iv = 0; iv < VL->NumVars(); iv++) res[iv][i_agglo] += res[iv][i];
  };
};


#include "CoarseGridBResCorr.cc"

#endif
