// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Sun May 2 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef CoarseGridReduceBoundary_HH
#define CoarseGridReduceBoundary_HH

#include <mouse_config.h>

template <class POP> class CoarseGridReduceBoundary;

#include <mouse_types.hh>
#include <ConstructArg.hh>
#include <CoarseGridBoundaryOperator.hh>

/**
*/
template <class POP>
class CoarseGridReduceBoundary : public CoarseGridBoundaryOperator<POP>
{
protected:

public:
  /** */ CoarseGridReduceBoundary (carg_t arg);
  /** */ virtual ~CoarseGridReduceBoundary ();
  /** */ void operate (size_t i_tmp, size_t i) {
    /*
    if (mga->BoundaryPoints(i) != NULL) {
      for (uint iv = 0; iv < VL->NumVars(); iv++) var[iv][i] = 0;
    };
    */

    for (uint iv = 0; iv < VL->NumVars(); iv++) {
      if (PL->code(i) == 0) var[iv][i] *= (1-mga->BRatio(i));
    };

  };
};


#include "CoarseGridReduceBoundary.cc"

#endif
