// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Mon Aug 16 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef CoarseGridResToBoundary_HH
#define CoarseGridResToBoundary_HH

#include <mouse_config.h>

template <class POP> class CoarseGridResToBoundary;

#include <mouse_types.hh>
#include <ConstructArg.hh>
#include <MultiGridAgent.hh>
#include <CoarseGridBoundaryOperator.hh>

/**
*/
template <class POP>
class CoarseGridResToBoundary : public CoarseGridBoundaryOperator<POP>
{
protected:

public:
  /** */ CoarseGridResToBoundary (carg_t arg);
  /** */ virtual ~CoarseGridResToBoundary ();
  /** */ void operate (size_t i_tmp, size_t i);
};

template <class POP>
inline void CoarseGridResToBoundary<POP>::operate(size_t i_tmp, size_t i)
{
  if (mga->IsHiddenNode(i)) {
    size_t i_agglo = mga->FieldPoint(i);
    for (uint iv = 0; iv < VL->NumVars(); iv++) {
      var[iv][i] = PL->Vol(i)*PL->IVol(i_agglo)*var[iv][i_agglo];
      cout << var[iv][i_agglo] << " " << var[iv][i] << endl;
    };
  };
};

#include "CoarseGridResToBoundary.cc"

#endif



