#include <BroadcastEvent.hh>

template<class POP>
CoarsenMesh2D<POP>::CoarsenMesh2D(carg_t arg) : MObject(arg)
{
  AddClassName();

  // Get pointers to the declared empty mesh structures
  PL = FindObject<PointList>(false, true);
  BPL = FindObject<BoundaryPointList>(false, true);
  //POPL = FindObject<POP>(false, true);
  FindObject(POPL, false, true);

  // get the fine grid informations
  //mg_agent = ResolveVar<MultiGridAgent<POP> >(arg);
  ResolveVar(mg_agent, arg);


  //MultiGridAgent<POP> *mga = FindObject<MultiGridAgent<POP> >(false, true);
  //mg_agent = mga->Prev();
  //if (mg_agent == NULL) Error("there is no MultiGridAgent for this level");
  PL_F = mg_agent->FinePL();
  POPL_F = mg_agent->FinePOP();
  BPL_F = mg_agent->FineBPL();

  // provide coarse grid information to the MultiGridAgent
  VarList *VL = FindObject<VarList>(false, true);
  mg_agent->SetCoarsePL(PL);
  mg_agent->SetCoarseBPL(BPL);
  mg_agent->SetCoarseVL(VL);
  mg_agent->SetCoarsePOP(POPL);

  // let everyone know that we are here
  BroadcastEvent E("CoarsenMesh2D_created");
  E.only_same_mesh = true;
  SendEvent(E);
};
