#include <ConstructArg.hh>

template<class POP>
CoarsenedStructBlock2D<POP>::CoarsenedStructBlock2D(carg_t arg) :
  StructuredBlock2D<POP>(arg)
{
  AddClassName();
  fine_grid = ResolveVar<StructuredBlock2D<POP> >(arg);
  mg_agent = ResolveVar<MultiGridAgent<POP> >(arg);
  mg_agent->SetCoarsePL(PL);
  mg_agent->SetCoarsePOP(POPL);
  VarList *VL = FindObject<VarList>(false, true);
  mg_agent->SetCoarseVL(VL);
  size_t a_imax = (fine_grid->IMax()+1)/2;
  size_t a_jmax = (fine_grid->JMax()+1)/2;
  i_linked = fine_grid->ILinked();
  j_linked = fine_grid->JLinked();
  InitBlock(a_imax, a_jmax);
  real w1 = 1;
  real w2 = 2;
  real w4 = 4;
  for (size_t i=0; i<imax; i++) {
    for (size_t j=0; j<jmax; j++) {
      Set(i, j, fine_grid->x(2*i,2*j), fine_grid->y(2*i,2*j), fine_grid->code(2*i,2*j));
      size_t p_coarse = point(i,j);
      mg_agent->SetCoarsePoint(fine_grid->point(2*i,2*j), p_coarse, w4);
      try {
	size_t p_fine = fine_grid->GoLeft(2*i,2*j);
	mg_agent->SetCoarsePoint(p_fine, p_coarse, w2);
	try {
	  size_t p_fine = fine_grid->GoUp(2*i-1,2*j);
	  mg_agent->SetCoarsePoint(p_fine, p_coarse, w1);
	} catch (IllegalPoint_error) {};
	try {
	  size_t p_fine = fine_grid->GoDown(2*i-1,2*j);
	  mg_agent->SetCoarsePoint(p_fine, p_coarse, w1);
	} catch (IllegalPoint_error) {};
      } catch (IllegalPoint_error) {};
      try {
	size_t p_fine = fine_grid->GoUp(2*i,2*j);
	mg_agent->SetCoarsePoint(p_fine, p_coarse, w2);
      } catch (IllegalPoint_error) {};
      try {
	size_t p_fine = fine_grid->GoDown(2*i,2*j);
	mg_agent->SetCoarsePoint(p_fine, p_coarse, w2);
      } catch (IllegalPoint_error) {};
      try {
	size_t p_fine = fine_grid->GoRight(2*i,2*j);
	mg_agent->SetCoarsePoint(p_fine, p_coarse, w2);
	try {
	  size_t p_fine = fine_grid->GoUp(2*i+1,2*j);
	  mg_agent->SetCoarsePoint(p_fine, p_coarse, w1);
	} catch (IllegalPoint_error) {};
	try {
	  size_t p_fine = fine_grid->GoDown(2*i+1,2*j);
	  mg_agent->SetCoarsePoint(p_fine, p_coarse, w1);
	} catch (IllegalPoint_error) {};
      } catch (IllegalPoint_error) {};
    };
  };
  AddEdgesToPop();
  mg_agent->UpdateWeights();
};
