// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Fri Aug 20 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "ComputeCoarseGridBoundaryGrad2D.hh"

#ifndef ComputeCoarseGridBoundaryGrad2D_CC
#define ComputeCoarseGridBoundaryGrad2D_CC

template <class POP>
ComputeCoarseGridBoundaryGrad2D<POP>::ComputeCoarseGridBoundaryGrad2D(carg_t arg)
  : CoarseGridBoundaryOperator<POP>(arg)
{
  AddClassName();
  //POPL = FindObject<POP>(false, true);
  FindObject(POPL, false, true);
  //BPL = FindObject<BoundaryPointList>(false, true);
  FindObject(BPL, false, true);
  dv_dx = VL->Get2DVar("gradx");
  dv_dy = VL->Get2DVar("grady");
};

template <class POP>
ComputeCoarseGridBoundaryGrad2D<POP>::~ComputeCoarseGridBoundaryGrad2D()
{
};

#endif

