#include <CppConstructArg.hh>

template<class POP>
MultiGridCoarseGridSetup<POP>::MultiGridCoarseGridSetup(carg_t arg) : Action(arg)
{
  AddClassName();
  string res_name = arg.P->ReadString();
  compute_res = BuildObject<Action>(arg);
  compute_source = new 
    TPOperation<ComputeSource, POP>
    (ccarg_t(this) + (ccarg_t(this) + (ccarg_t(this) + res_name)));
};

template<class POP>
MultiGridCoarseGridSetup<POP>::ComputeSource::ComputeSource(carg_t arg)
  : Operator(arg)
{
  AddClassName();
  string res_name = arg.P->ReadString();
  VarList *VL = FindObject<VarList>(false, true);
  source = VL->Get2DVar("mg_source");
  res = VL->Get2DVar(res_name);
};

template<class POP>
void MultiGridCoarseGridSetup<POP>::Act()
{
  compute_res->Act();
  compute_source->Act();
};
