#ifndef MultiGridProlongation_HH
#define MultiGridProlongation_HH

template<class POP> class MultiGridProlongation;

#include <MultiGridTransferOperator.hh>

/**
   a transfer operator to get a vector from a coarse to a fine grid
*/
template<class POP>
class MultiGridProlongation : public MultiGridTransferOperator<POP>
{
public:
  /** */ MultiGridProlongation(carg_t arg) : MultiGridTransferOperator<POP>(arg) { 
    AddClassName(); 
  };

  /** */ void operate(size_t i_tmp, size_t i_fine);
};

template<class POP>
inline void MultiGridProlongation<POP>::operate(size_t i_tmp, size_t i_fine)
{
  if (TransferPoint(i_fine)) {
    size_t i_coarse = mg_agent->CoarsePoint(i_fine);
    for (size_t i_var = 0; i_var < VL->NumVars(); i_var++) {
      var_fine[i_var][i_fine] += factor * var_coarse[i_var][i_coarse];
    };
  };
};

#endif
