#ifndef MultiGridResetCoarse_HH
#define MultiGridResetCoarse_HH

template<class POP> class MultiGridResetCoarse;

#include <MultiGridAgent.hh>
#include <Operator.hh>

/**
   sets the coarse fields to zero
*/
template<class POP>
class MultiGridResetCoarse : public Operator
{
protected:
  /**
     a variable for the new variable field
  */
  VarContainer::var2_t var_new;

  /**
     a variable for the residual field
  */
  VarContainer::var2_t var_res;

  /**
     a variable for the source term field
  */
  VarContainer::var2_t var_source;

  /**
     the agent handling this pair of grids
  */
  MultiGridAgent<POP> *mg_agent;
  
public:
  /** */ MultiGridResetCoarse(carg_t arg);
  /** */ void operate(size_t i_tmp, size_t i);
};

template<class POP>
inline void  MultiGridResetCoarse<POP>::operate(size_t i_tmp, size_t i)
{
  for (size_t iv=0; iv<VL->NumVars(); iv++) {
    var_res[iv][mg_agent->CoarsePoint(i)] = 0.0;
    var_new[iv][mg_agent->CoarsePoint(i)] = 0.0;
    var_source[iv][mg_agent->CoarsePoint(i)] = 0.0;
  };
};

#include "MultiGridResetCoarse.cc"

#endif

