#ifndef MultiGridRestriction_HH
#define MultiGridRestriction_HH

template<class POP> class MultiGridRestriction;

#include <MultiGridTransferOperator.hh>

/**
   a transfer operator to get a vector from a fine to a coarse grid
*/
template<class POP>
class MultiGridRestriction : public MultiGridTransferOperator<POP>
{
public:
  /** */ MultiGridRestriction(carg_t arg) : MultiGridTransferOperator<POP>(arg) { 
    AddClassName(); 
  };

  /** */ void operate(size_t i_tmp, size_t i_fine);
};

template<class POP>
inline void MultiGridRestriction<POP>::operate(size_t i_tmp, size_t i_fine)
{
  if (TransferPoint(i_fine)) {
    size_t i_coarse = mg_agent->CoarsePoint(i_fine);
    for (size_t i_var = 0; i_var < VL->NumVars(); i_var++) {
      var_coarse[i_var][i_coarse] += factor * var_fine[i_var][i_fine];
    };
  };
};

#endif
