#ifndef MultiGridTransferToCoarse_HH
#define MultiGridTransferToCoarse_HH

template<class POP> class MultiGridTransferToCoarse;

#include <MultiGridResetCoarse.hh>
#include <MultiGridRestriction.hh>
#include <MultiGridWeightedRestriction.hh>
#include <Action.hh>

template<class POP>
class MultiGridTransferToCoarse : public Action
{
protected:
  /**
     the agent handling this pair of grids
  */
  MultiGridAgent<POP> *mg_agent;

  /**
     an Action to reset the coarse fields
  */
  Action *reset_coarse;

  /**
     an Action to transfer the variable vector
  */
  Action *restr_new;

  /**
     an Action to transfer the residual vector
  */
  Action *restr_res;

public:
  /** */ MultiGridTransferToCoarse(carg_t arg);
  /** */ virtual void Act();
};

#include "MultiGridTransferToCoarse.cc"

#endif
