// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Mon Jun 7 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef SmallVector_HH
#define SmallVector_HH

#include <mouse_config.h>

template <class T, uint N> class SmallVector;

#include <mouse_types.hh>
#include <ConstructArg.hh>

/**
*/
template <class T, uint N>
class SmallVector
{
protected:
  /** */ T V[N];

public:
  /** */ SmallVector() {};
  /** */ SmallVector(const SmallVector<T,N> &vec) {
    for (uint i = 0; i < N; i++) V[i] = vec[i]; 
  };

  /** */ T& operator[] (uint i) { return V[i]; };
  /** */ T operator[] (uint i) const { return V[i]; };

  /** */ template <class aT, uint aN> 
  friend ostream& operator<<(ostream &s, const SmallVector<aT,aN> vec);

  /** */ void operator= (const SmallVector<T,N> &vec) {
    for (uint i = 0; i < N; i++) V[i] = vec[i]; 
  };
};


#include "SmallVector.cc"

#endif
