#ifndef StructuredBlock2D_HH
#define StructuredBlock2D_HH

template<class POP> class StructuredBlock2D;

#include <PointList.hh>
#include <geometry2D.hh>

template<class POP>
class StructuredBlock2D : public MObject
{
protected:
  /** */ struct IllegalPoint_error {
    IllegalPoint_error() {};
  };

  /** */ size_t imax;
  /** */ size_t jmax;
  /** */ size_t origin;
  /** */ int c_dl;
  /** */ int c_l;
  /** */ int c_ul;
  /** */ int c_u;
  /** */ int c_ur;
  /** */ int c_r;
  /** */ int c_dr;
  /** */ int c_d;
  /** */ POP *POPL;
  /** */ PointList *PL;
  /** */ BoundaryPointList *BPL;
  /** */ ElementList *EL;
  /** */ bool i_linked;
  /** */ bool j_linked;
  /** */ real QuadX(size_t i, size_t j);
  /** */ real QuadY(size_t i, size_t j);
  /** */ void AddQuad(size_t p0, size_t p1, size_t p2, size_t p3);
  /** */ void AddEdgesToPop();

public:
  /** */ StructuredBlock2D(carg_t arg);
  /** */ void InitBlock(size_t a_imax, size_t a_jmax);
  /** */ virtual void HandleEvent(Event &E);
  /** */ size_t point(size_t i, size_t j) { return j*imax+i+origin; };
  /** */ real x(size_t i, size_t j) { return PL->x(point(i,j)); };
  /** */ real y(size_t i, size_t j) { return PL->y(point(i,j)); };
  /** */ int code(size_t i, size_t j) { return PL->code(point(i,j)); };
  /** */ void Set(size_t i, size_t j, real a_x, real a_y);
  /** */ void Set(size_t i, size_t j, real a_x, real a_y, int a_code);
  /** */ void Set(size_t i, size_t j, int a_code);
  /** */ size_t IMax() { return imax; };
  /** */ size_t JMax() { return jmax; };
  /** */ bool ILinked() { return i_linked; };
  /** */ bool JLinked() { return j_linked; };
  /** */ size_t GoUp(size_t i, size_t j);
  /** */ size_t GoDown(size_t i, size_t j);
  /** */ size_t GoLeft(size_t i, size_t j);
  /** */ size_t GoRight(size_t i, size_t j);
};

#include "StructuredBlock2D.cc"

#endif
