// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#ifdef TKEYLIST_H

//
//.. constructor
//
template<class TKey, class TValue>
TKeyList<TKey, TValue>::TKeyList (size_t max, size_t delta,
				  TKey default_key, TValue default_value) : 
  TList<TKey> (max, delta, default_key)
{
  Value = new TList<TValue> (this, default_value);
};

//
//.. Find
//
template<class TKey, class TValue>
size_t TKeyList<TKey, TValue>::Find (TKey key) const
{
  for(size_t i = begin(); i < end(); i = next(i)) {
    if (TList<TKey>::At(i) == key) return i;
  };
  throw NotFound_error();
};

//
//.. At
//
template<class TKey, class TValue>
TValue& TKeyList<TKey, TValue>::At (TKey key)
{
  for(size_t i = begin(); i < end(); i = next(i)) {
    if (TList<TKey>::At(i) == key) return Value->At(i);
  };
  //return Value->default_value;
  throw NotFound_error();
};

//
//.. NewEntry
//
template<class TKey, class TValue>
TValue& TKeyList<TKey, TValue>::NewEntry (TKey key)
{
  size_t i = List::AddEntry();
  TList<TKey>::At(i) = key;
  return Value->At(i);
};

#endif







