// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#if !defined(TKEYLIST_H)
#define TKEYLIST_H

template <class TKey, class TValue> class TKeyList;

#include "TList.hh"

/**
   an assosiative array
*/
template<class TKey, class TValue>
class TKeyList : public TList<TKey>
{
protected:
  /** list for the corresponding values. */
  TList<TValue> *Value;

public:
  /** constructor. */
  TKeyList (size_t max, size_t delta, TKey default_key, TValue default_value);

  /** @return the index for a given key. */
  size_t Find (TKey key) const;

  /** @return the value for a given key. */
  TValue& At (TKey key);

  /** */ TValue& ViAt(size_t i) { return Value->At(i); };
  /** */ TKey& KiAt(size_t i) { return TList<TKey>::At(i); };

  /** enter a new entry. */
  TValue& NewEntry (TKey key);
};

#include "TKeyList.cc"

#endif







