// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Sun May 23 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef VarDiffAdapt2D_HH
#define VarDiffAdapt2D_HH

#include <mouse_config.h>

template <class POP> class VarDiffAdapt2D;

#include <mouse_types.hh>
#include <ConstructArg.hh>
#include <Triangulator2D.hh>
#include <Mesh2DAction.hh>
#include <VarList.hh>

/**
*/
template <class POP>
class VarDiffAdapt2D : public Mesh2DAction
{
protected:
  /** */ VarList *VL;
  /** */ POP *POPL;
  /** */ VarContainer::var1_t gx;
  /** */ VarContainer::var1_t gy;
  /** */ real R_max;
  /** */ real R_min;
  /** */ real C1;
  /** */ real C2;

public:
  /** */ VarDiffAdapt2D (carg_t arg);
  /** */ virtual ~VarDiffAdapt2D ();
  /** */ virtual void Act();
};


#include "VarDiffAdapt2D.cc"

#endif
